unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, mmSystem, StdCtrls, ComCtrls, ShellApi, SvgEditIni,
  HookTimer, jpeg, Grids, ValEdit;

type
  TForm1 = class(TForm)
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    HookTimer1: THookTimer;
    CheckBox2: TCheckBox;
    Timer1: TTimer;
    CheckBox3: TCheckBox;
    GroupBox1: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Memo5: TMemo;
    Edit1: TEdit;
    Label9: TLabel;
    GroupBox2: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    ComboBox1: TComboBox;
    GroupBox3: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Image1: TImage;
    Panel1: TPanel;
    Label12: TLabel;
    Edit8: TEdit;
    Label8: TLabel;
    Label7: TLabel;
    Edit7: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    GroupBox4: TGroupBox;
    StringGrid1: TStringGrid;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure HookTimer1MouseMove(Sender: TObject; Shift: TShiftState;
      PrevX, PrevY, X, Y: Integer);
    procedure CheckBox2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);



  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  i : integer;
  xx,yy,zz : integer; //Positions de la camra
  vx,vy,vz : integer; //coordonnes Vitesse de dplacement
  pitch,yaw,roll : integer; // direction
  pasxyz : integer; //Pas de dplacement = norme de la vitesse
  bascule, bascule2 : boolean; // permet de basculer Freecam ou pas freecam
  accel, lataccel : real;
  xx1,yy1,zz1,pitch1,yaw1,roll1,xx2,yy2,zz2,pitch2,yaw2,roll2 : real;
  xxt,yyt,zzt,pitcht,yawt,rollt : string;
  xxtemp,yytemp,zztemp,pitchtemp,yawtemp,rolltemp : real;
  etape : integer;
  nbdecomp : integer;
  spos, sposprec : string;
  nbwp : integer;

implementation

{$R *.dfm}


procedure Ecris(s:string); //Permet d'crire dans la console donc d'envoyer des commandes  ET
var
  wnd: HWND;
  i: Integer;
begin
  wnd := FindWindow('ET WinConsole','ET Console');
  if wnd <> 0 then
  begin
    wnd := FindWindowEx(wnd, 0, 'Edit', nil);

    for i := 1 to Length(s) do
      SendMessage(wnd, WM_CHAR, Word(s[i]), 0);

    PostMessage(wnd, WM_KEYDOWN, VK_RETURN, 0);
    PostMessage(wnd, WM_KEYDOWN, VK_SPACE, 0);
  end;
end;



procedure TForm1.FormCreate(Sender: TObject);
var
  cHK: char;
  touche : cardinal;
begin

  //initialisation des variables
  xx :=0;
  yy :=0;
  zz :=0;
  pitch:=0;
  yaw:=0;
  roll:=0;
  vx:=0;
  vy:=0;
  vz:=0;

  nbdecomp :=1000;

  sposprec :='';

  etape := 0;

  pasxyz := 0;

  Edit1.Text := IntToStr(pasxyz);

  nbwp :=0;

  accel :=0;

  bascule := false; //mode freecam : bascule true et pas freecam : bascule false;


end;


procedure TForm1.Button2Click(Sender: TObject);
var
  f : textfile;
begin
  assignfile (f,'LNACam.camera');
  rewrite (f);
  writeln (f,'cameraPathDef { ');
  writeln (f,'	time '+ComboBox1.Text);
  writeln (f,'	camera_Spline {');
  writeln (f,'		time '+ComboBox1.Text+'000');
  writeln (f,'		type 2');
  writeln (f,'		name position');
  writeln (f,'		baseVelocity 0');
  writeln (f,'		target {');
  writeln (f,'			granularity 0.0010000');
  for i := 0 to Memo1.Lines.Count-1 do
  begin
    writeln (f,Memo1.Lines[i]);
  end;
  writeln (f,'		}');
  writeln (f,'	}');
  writeln (f,'	target_Spline {');
  writeln (f,'		time '+ComboBox1.Text+'000');
  writeln (f,'		type 2');
  writeln (f,'		name target1');
  writeln (f,'		baseVelocity 0');
  writeln (f,'		target {');
  writeln (f,'			granularity 0.0010000');
  for i := 0 to Memo2.Lines.Count-1 do
  begin
    writeln (f,Memo2.Lines[i]);
  end;
  for i := 0 to Memo5.Lines.Count-1 do
  begin
    writeln (f,Memo5.Lines[i]);
  end;
  closefile(f);
end;



procedure TForm1.Label5Click(Sender: TObject);
begin
  ShellExecute(0,                // Handle d'une fentre
    'open',                      // Opration  effectuer
    'http://www.clan-lna.net/',    // Application  lancer ou document  ouvrir
    '',                          // Arguments de la ligne de commande
    '',                          // Rpertoire par dfaut
    SW_SHOWNORMAL);
end;

procedure TForm1.HookTimer1MouseMove(Sender: TObject; Shift: TShiftState;
  PrevX, PrevY, X, Y: Integer);
begin
//  If CheckBox1.Checked then pitch := pitch + (Y-PrevY) else pitch := pitch - (Y-PrevY);
//  yaw := yaw - (X-prevX);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  HookTimer1.Enabled := CheckBox2.Checked;
  Timer1.Enabled := CheckBox2.Checked;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i : integer;
begin
  memo1.Clear;
  memo2.Clear;
  for i := 0 to 100 do
  begin
    StringGrid1.Cells[0,i]:='';
    StringGrid1.Cells[1,i]:='';
    StringGrid1.Cells[2,i]:='';
    StringGrid1.Cells[3,i]:='';
  end;
  nbwp:=0;
  StringGrid1.TopRow := 0;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  acceleration, accelerationlat : boolean;
  xxtnt,yytnt,zztnt,pitchtnt,yawtnt, rolltnt : real;

begin

  if (GetKeyState(VK_NUMPAD0)<0) and false then
  begin
    etape := 0;
    CheckBox3.Checked := false;
    sleep(50);
  end;

  if GetKeyState(VK_INSERT) < 0 then
  begin
    if not bascule then
    begin
      //lance la freecam
      ecris ('freecam');
      sleep (50);
//      ecris ('echo Freecam ON');
//      sleep (50);
      // setting this to 0 lets you use your own keybinds in demo playback
      ecris ('b_predefineddemokeys 0');
      sleep (50);
//      ecris ('echo b_predefineddemokeys 0');
//      sleep (50);
      ecris ('noclip');
      sleep(50);
//      ecris ('echo b_predefineddemokeys 0');
//      sleep (50);
      // demande  la freecam de se positionner en 0 0 0 0 0 0
      ecris ('freecamSetPos '+IntToStr(xx)+' '+IntToStr(yy)+' '+IntToStr(zz)+' '+IntToStr(pitch)+' '+IntToStr(yaw)+' '+IntToStr(roll));
      sleep (50);
      bascule := true;
      Label12.Font.Color := clRed;
      Panel1.BevelOuter := bvLowered;
    end
    else
    begin
      //lance la freecam
      ecris ('freecam');
      sleep (50);
//      ecris ('echo Freecam Off');
//      sleep (50);
      // setting this to 0 lets you use your own keybinds in demo playback
      ecris ('b_predefineddemokeys 1');
      sleep (50);
//      ecris ('echo b_predefineddemokeys 1');
//      sleep (50);
      ecris ('noclip');
      sleep(50);
//      ecris ('echo noclip Off');
//      sleep (50);
      bascule := false;
      Label12.Font.Color := clSilver;
      Panel1.BevelOuter := bvRaised;
      pasxyz:=0;
      Edit1.Text := '0';
    end

  end;

  if GetKeyState(VK_PRIOR) < 0 then
  begin
    inc(pasxyz);
    Edit1.Text := IntToStr(pasxyz);
  end;

  if GetKeyState(VK_NEXT) < 0 then
  begin
    dec(pasxyz);
    Edit1.Text := IntToStr(pasxyz);
  end;

  if GetKeyState(VK_numpad8) < 0 then
  begin
    pitch := pitch + 2;
  end;

  if GetKeyState(VK_numpad2) < 0 then
  begin
    pitch := pitch - 2;
  end;



  xx := xx + round(pasxyz*cos(pitch/180*3.14)*cos(yaw/180*3.14));
  yy := yy + round(pasxyz*cos(pitch/180*3.14)*sin(yaw/180*3.14));
  zz := zz - round(pasxyz*sin(pitch/180*3.14));

  Edit3.Text := IntToStr(xx);
  Edit4.Text := IntToStr(yy);
  Edit5.Text := IntToStr(zz);
  Edit6.Text := IntToStr(pitch);
  Edit7.Text := IntToStr(yaw);
  Edit8.Text := IntToStr(roll);


  if GetKeyState(VK_NUMPAD4) < 0 then
  begin
    yaw := yaw + 2;
  end;

  if GetKeyState(VK_NUMPAD6) < 0 then
  begin
    yaw := yaw - 2;
  end;

  if GetKeyState(VK_NUMPAD7) < 0 then
  begin
    roll := roll-2;
  end;

  if GetKeyState(VK_NUMPAD9) < 0  then
  begin
    roll := roll+2;
  end;




  if (GetKeyState(VK_DELETE) < 0) and bascule then
  begin
    Memo1.Lines.Add('			( '+IntToStr(xx)+' '+IntToStr(yy)+' '+IntToStr(zz)+' )');
    Memo2.Lines.Add('			( '+IntToStr(xx + round(100*cos(pitch/180*3.14)*cos(yaw/180*3.14)))+' '+
                              IntToStr(yy + round(100*cos(pitch/180*3.14)*sin(yaw/180*3.14)))+' '+
                              IntToStr(zz - round(100*sin(pitch/180*3.14)))+' )');
    if nbwp = 0 then
    begin
          Memo1.Lines.Add('			( '+IntToStr(xx + round(10*cos(pitch/180*3.14)*cos(yaw/180*3.14)))+' '+
                              IntToStr(yy + round(100*cos(pitch/180*3.14)*sin(yaw/180*3.14)))+' '+
                              IntToStr(zz - round(100*sin(pitch/180*3.14)))+' )');
          Memo2.Lines.Add('			( '+IntToStr(xx + round(20*cos(pitch/180*3.14)*cos(yaw/180*3.14)))+' '+
                              IntToStr(yy + round(200*cos(pitch/180*3.14)*sin(yaw/180*3.14)))+' '+
                              IntToStr(zz - round(200*sin(pitch/180*3.14)))+' )');

    end;

    Sleep (100);
    StringGrid1.Cells[0,nbwp]:=IntToStr(nbwp+1);
    StringGrid1.Cells[1,nbwp]:=IntToStr(xx);
    StringGrid1.Cells[2,nbwp]:=IntToStr(yy);
    StringGrid1.Cells[3,nbwp]:=IntToStr(zz);
    if nbwp>=4 then StringGrid1.TopRow := nbwp-4 else StringGrid1.TopRow := 0;
    inc(nbwp);


  end;

  if bascule then
  begin
    ecris ('freecamSetPos '+IntToStr(xx)+' '+IntToStr(yy)+' '+IntToStr(zz)+' '+IntToStr(pitch+round(accel*5))+' '+IntToStr(yaw)+' '+IntToStr(roll+round(lataccel*5)));
    sleep (50);
  end;

end;





procedure TForm1.Button3Click(Sender: TObject);
begin
  ecris ('camera LNACam');
end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  if nbwp>1 then
  begin
    dec(nbwp);
    Memo1.Lines.Delete(Memo1.Lines.Count-1);
    Memo2.Lines.Delete(Memo2.Lines.Count-1);
    StringGrid1.Cells[0,nbwp]:='';
    StringGrid1.Cells[1,nbwp]:='';
    StringGrid1.Cells[2,nbwp]:='';
    StringGrid1.Cells[3,nbwp]:='';
    if nbwp>=4 then StringGrid1.TopRow := nbwp-4 else StringGrid1.TopRow := 0;
  end
  else
  if nbwp=1 then
  begin
    dec(nbwp);
    Memo1.Lines.Delete(Memo1.Lines.Count-1);
    Memo1.Lines.Delete(Memo1.Lines.Count-1);
    Memo2.Lines.Delete(Memo2.Lines.Count-1);
    Memo2.Lines.Delete(Memo2.Lines.Count-1);
    StringGrid1.Cells[0,nbwp]:='';
    StringGrid1.Cells[1,nbwp]:='';
    StringGrid1.Cells[2,nbwp]:='';
    StringGrid1.Cells[3,nbwp]:='';
    StringGrid1.TopRow := 0;
  end;

end;

end.

{VK_LBUTTON
    The left mouse button
VK_RBUTTON
    The right mouse button
VK_MBUTTON
    The middle mouse button
VK_BACK
    Backspace
VK_TAB
    Tab
VK_CLEAR
    5 (keypad without Num Lock)
VK_RETURN
    Enter
VK_SHIFT
    Shift (either one)
VK_CONTROL
    Ctrl (either one)
VK_MENU
    Alt (either one)
VK_PAUSE
    Pause
VK_CAPITAL
    Caps Lock
VK_ESCAPE
    Esc
VK_SPACE
    Spacebar
VK_PRIOR
    Page Up
VK_NEXT
    Page Down
VK_END
    End
VK_HOME
    Home 
VK_LEFT
    Left Arrow
VK_UP
    Up Arrow 
VK_RIGHT
    Right Arrow
VK_DOWN
    Down Arrow 
VK_SELECT
    Select
VK_PRINT
    Print (only used by Nokia keyboards) 
VK_EXECUTE
    Execute (not used)
VK_SNAPSHOT
    Print Screen 
VK_INSERT
    Insert
VK_DELETE
    Delete 
VK_HELP
    Help 
VK_0
    0
VK_1
    1 
VK_2
    2 
VK_3
    3 
VK_4
    4
VK_5
    5
VK_6
    6
VK_7
    7
VK_8
    8
VK_9
    9 
VK_A
    A 
VK_B
    B 
VK_C
    C 
VK_D
    D 
VK_E
    E
VK_F
    F 
VK_G
    G
VK_H
    H 
VK_I
    I
VK_J
    J 
VK_K
    K 
VK_L
    L 
VK_M
    M 
VK_N
    N
VK_O
    O 
VK_P
    P 
VK_Q
    Q 
VK_R
    R 
VK_S
    S
VK_T
    T 
VK_U
    U 
VK_V
    V 
VK_W
    W 
VK_X
    X
VK_Y
    Y 
VK_Z
    Z 
VK_STARTKEY
    Start Menu key 
VK_CONTEXTKEY
    Context Menu key 
VK_NUMPAD0
    0 (keypad with Num Lock)
VK_NUMPAD1
    1 (keypad with Num Lock) 
VK_NUMPAD2
    2 (keypad with Num Lock) 
VK_NUMPAD3
    3 (keypad with Num Lock) 
VK_NUMPAD4
    4 (keypad with Num Lock) 
VK_NUMPAD5
    5 (keypad with Num Lock)
VK_NUMPAD6
    6 (keypad with Num Lock) 
VK_NUMPAD7
    7 (keypad with Num Lock) 
VK_NUMPAD8
    8 (keypad with Num Lock) 
VK_NUMPAD9
    9 (keypad with Num Lock) 
VK_MULTIPLY
    * (keypad)
VK_ADD
    + (keypad) 
VK_SEPARATER
    Separator (never generated by the keyboard) 
VK_DECIMAL
    . (keypad with Num Lock) 
VK_DIVIDE
    / (keypad) 
VK_F1
    F1
VK_F2
    F2 
VK_F3
    F3 
VK_F4
    F4 
VK_F5
    F5 
VK_F6
    F6
VK_F7
    F7 
VK_F8
    F8
VK_F9
    F9 
VK_F10
    F10
VK_F11
    F11 
VK_F12
    F12
VK_F13
    F13 
VK_F14
    F14
VK_F15
    F15 
VK_F16
    F16
VK_F17
    F17 
VK_F18
    F18
VK_F19
    F19 
VK_F20
    F20
VK_F21
    F21 
VK_F22
    F22
VK_F23
    F23 
VK_F24
    F24
VK_NUMLOCK
    Num Lock 
VK_OEM_SCROLL
    Scroll Lock
VK_OEM_1
    ; 
VK_OEM_PLUS
    =
VK_OEM_COMMA
    , 
VK_OEM_MINUS
    -
VK_OEM_PERIOD
    . 
VK_OEM_2
    /
VK_OEM_3
    ` 
VK_OEM_4
    [ 
VK_OEM_5
    \
VK_OEM_6
    ] 
VK_OEM_7
    ' 
VK_OEM_8
    (unknown)
VK_ICO_F17
    F17 on Olivetti extended keyboard (internal use only) 
VK_ICO_F18
    F18 on Olivetti extended keyboard (internal use only) 
VK_OEM_102
    < or | on IBM-compatible 102 enhanced non-U.S. keyboard
VK_ICO_HELP
    Help on Olivetti extended keyboard (internal use only) 
VK_ICO_00
    00 on Olivetti extended keyboard (internal use only) 
VK_ICO_CLEAR
    Clear on Olivette extended keyboard (internal use only) 
VK_OEM_RESET
    Reset (Nokia keyboards only) 
VK_OEM_JUMP
    Jump (Nokia keyboards only) 
VK_OEM_PA1
    PA1 (Nokia keyboards only) 
VK_OEM_PA2
    PA2 (Nokia keyboards only) 
VK_OEM_PA3
    PA3 (Nokia keyboards only) 
VK_OEM_WSCTRL
    WSCTRL (Nokia keyboards only) 
VK_OEM_CUSEL
    CUSEL (Nokia keyboards only) 
VK_OEM_ATTN
    ATTN (Nokia keyboards only)
VK_OEM_FINNISH
    FINNISH (Nokia keyboards only)
VK_OEM_COPY
    COPY (Nokia keyboards only)
VK_OEM_AUTO
    AUTO (Nokia keyboards only)
VK_OEM_ENLW
    ENLW (Nokia keyboards only)
VK_OEM_BACKTAB
    BACKTAB (Nokia keyboards only)
VK_ATTN
    ATTN
VK_CRSEL
    CRSEL
VK_EXSEL
    EXSEL
VK_EREOF
    EREOF
VK_PLAY
    PLAY
VK_ZOOM
    ZOOM
VK_NONAME
    NONAME
VK_PA1
    PA1
VK_OEM_CLEAR
    CLEAR}
